<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.3"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: include/resources/Attributes.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectalign">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.3 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "search",'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_d44c64559bbebec7f509842c48db8b23.html">include</a></li><li class="navelem"><a class="el" href="dir_b1edfc2c49307e65a973a203b2244023.html">resources</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle"><div class="title">Attributes.hpp</div></div>
</div><!--header-->
<div class="contents">
<a href="Attributes_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a id="l00001" name="l00001"></a><span class="lineno">    1</span><span class="preprocessor">#pragma once</span></div>
<div class="line"><a id="l00002" name="l00002"></a><span class="lineno">    2</span> </div>
<div class="line"><a id="l00003" name="l00003"></a><span class="lineno">    3</span><span class="preprocessor">#include &lt;SFML/Graphics.hpp&gt;</span></div>
<div class="line"><a id="l00004" name="l00004"></a><span class="lineno">    4</span> </div>
<div class="line"><a id="l00005" name="l00005"></a><span class="lineno">    5</span><span class="keyword">namespace </span><a class="code hl_namespace" href="namespacegg.html">gg</a></div>
<div class="line"><a id="l00006" name="l00006"></a><span class="lineno">    6</span>{</div>
<div class="line"><a id="l00007" name="l00007"></a><span class="lineno">    7</span> </div>
<div class="line"><a id="l00008" name="l00008"></a><span class="lineno">    8</span><span class="keyword">enum class</span> <a class="code hl_enumeration" href="namespacegg.html#a8ae82840d9f1b628101cb24cf296c26d">HAlignment</a>;</div>
<div class="line"><a id="l00009" name="l00009"></a><span class="lineno">    9</span><span class="keyword">enum class</span> <a class="code hl_enumeration" href="namespacegg.html#a590f5e8566d42718b935361a0172b54d">VAlignment</a>;</div>
<div class="line"><a id="l00010" name="l00010"></a><span class="lineno">   10</span><span class="keyword">struct </span>Margins;</div>
<div class="line"><a id="l00011" name="l00011"></a><span class="lineno">   11</span><span class="keyword">class </span>XMLDocument;</div>
<div class="line"><a id="l00012" name="l00012"></a><span class="lineno">   12</span> </div>
<div class="line"><a id="l00013" name="l00013"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html">   13</a></span><span class="keyword">class </span><a class="code hl_class" href="classgg_1_1Attributes.html">Attributes</a></div>
<div class="line"><a id="l00014" name="l00014"></a><span class="lineno">   14</span>{</div>
<div class="line"><a id="l00015" name="l00015"></a><span class="lineno">   15</span>  <span class="keyword">public</span>:</div>
<div class="line"><a id="l00016" name="l00016"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html#afad9a1871b7ec801c4c40446a5022bbe">   16</a></span>    <a class="code hl_function" href="classgg_1_1Attributes.html#afad9a1871b7ec801c4c40446a5022bbe">Attributes</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00017" name="l00017"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html#ac0a763b9415d0addc52f108b2febefa1">   17</a></span>    <span class="keyword">virtual</span> <a class="code hl_function" href="classgg_1_1Attributes.html#ac0a763b9415d0addc52f108b2febefa1">~Attributes</a>() = <span class="keywordflow">default</span>;</div>
<div class="line"><a id="l00018" name="l00018"></a><span class="lineno">   18</span> </div>
<div class="line"><a id="l00019" name="l00019"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html#a9f8f053a797c33195cd823bbe91a24a8">   19</a></span>    <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a9f8f053a797c33195cd823bbe91a24a8">Add</a>(<span class="keyword">const</span> std::string &amp;, <span class="keyword">const</span> std::string &amp;);</div>
<div class="line"><a id="l00020" name="l00020"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html#ae2128837ba7b64ae153d8b054d32af58">   20</a></span>    [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#ae2128837ba7b64ae153d8b054d32af58">Has</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; bool;</div>
<div class="line"><a id="l00021" name="l00021"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">   21</a></span>    [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; std::string;</div>
<div class="line"><a id="l00022" name="l00022"></a><span class="lineno">   22</span> </div>
<div class="line"><a id="l00023" name="l00023"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html#a44e4ec4f45130e843b036c764c9effff">   23</a></span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a44e4ec4f45130e843b036c764c9effff">Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; <a class="code hl_enumvalue" href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ab9ece18c950afbfa6b0fdbfa4ff731d3">T</a>;</div>
<div class="line"><a id="l00024" name="l00024"></a><span class="lineno">   24</span> </div>
<div class="line"><a id="l00025" name="l00025"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html#ad955fb8678355b77c60907fe41f754e9">   25</a></span>    [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#ad955fb8678355b77c60907fe41f754e9">GetLibrary</a>() const -&gt; const <a class="code hl_namespace" href="namespacestd.html">std</a>::map&lt;<a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span>, <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span>&gt;;</div>
<div class="line"><a id="l00026" name="l00026"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html#aac496caf3931b8885961264bf2015024">   26</a></span>    inline <span class="keywordtype">void</span> <a class="code hl_function" href="classgg_1_1Attributes.html#aac496caf3931b8885961264bf2015024">SetLibrary</a>(<a class="code hl_namespace" href="namespacestd.html">std</a>::map&lt;<a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span>, <a class="code hl_namespace" href="namespacestd.html">std</a>::<span class="keywordtype">string</span>&gt; &amp;new_attr_library)</div>
<div class="line"><a id="l00027" name="l00027"></a><span class="lineno">   27</span>    {</div>
<div class="line"><a id="l00028" name="l00028"></a><span class="lineno">   28</span>        mAttributeLibrary = new_attr_library;</div>
<div class="line"><a id="l00029" name="l00029"></a><span class="lineno">   29</span>    }</div>
<div class="line"><a id="l00030" name="l00030"></a><span class="lineno">   30</span> </div>
<div class="line"><a id="l00031" name="l00031"></a><span class="lineno">   31</span>  <span class="keyword">private</span>:</div>
<div class="line"><a id="l00032" name="l00032"></a><span class="lineno">   32</span>    std::map&lt;std::string, std::string&gt; mAttributeLibrary;</div>
<div class="line"><a id="l00033" name="l00033"></a><span class="lineno">   33</span>};</div>
<div class="line"><a id="l00034" name="l00034"></a><span class="lineno">   34</span> </div>
<div class="line"><a id="l00035" name="l00035"></a><span class="lineno"><a class="line" href="classgg_1_1Attributes.html#a8a40b7be607ea51e4fdcc7ab7237a46e">   35</a></span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; bool;</div>
<div class="line"><a id="l00036" name="l00036"></a><span class="lineno">   36</span> </div>
<div class="line"><a id="l00037" name="l00037"></a><span class="lineno">   37</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; int;</div>
<div class="line"><a id="l00038" name="l00038"></a><span class="lineno">   38</span> </div>
<div class="line"><a id="l00039" name="l00039"></a><span class="lineno">   39</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; <span class="keywordtype">unsigned</span> int;</div>
<div class="line"><a id="l00040" name="l00040"></a><span class="lineno">   40</span> </div>
<div class="line"><a id="l00041" name="l00041"></a><span class="lineno">   41</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; float;</div>
<div class="line"><a id="l00042" name="l00042"></a><span class="lineno">   42</span> </div>
<div class="line"><a id="l00043" name="l00043"></a><span class="lineno">   43</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; double;</div>
<div class="line"><a id="l00044" name="l00044"></a><span class="lineno">   44</span> </div>
<div class="line"><a id="l00045" name="l00045"></a><span class="lineno">   45</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; sf::Vector2i;</div>
<div class="line"><a id="l00046" name="l00046"></a><span class="lineno">   46</span> </div>
<div class="line"><a id="l00047" name="l00047"></a><span class="lineno">   47</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; sf::Vector2f;</div>
<div class="line"><a id="l00048" name="l00048"></a><span class="lineno">   48</span> </div>
<div class="line"><a id="l00049" name="l00049"></a><span class="lineno">   49</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; sf::Color;</div>
<div class="line"><a id="l00050" name="l00050"></a><span class="lineno">   50</span> </div>
<div class="line"><a id="l00051" name="l00051"></a><span class="lineno">   51</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; <span class="keyword">const</span> sf::Font &amp;;</div>
<div class="line"><a id="l00052" name="l00052"></a><span class="lineno">   52</span> </div>
<div class="line"><a id="l00053" name="l00053"></a><span class="lineno">   53</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; <a class="code hl_enumeration" href="namespacegg.html#a590f5e8566d42718b935361a0172b54d">VAlignment</a>;</div>
<div class="line"><a id="l00054" name="l00054"></a><span class="lineno">   54</span> </div>
<div class="line"><a id="l00055" name="l00055"></a><span class="lineno">   55</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; <a class="code hl_enumeration" href="namespacegg.html#a8ae82840d9f1b628101cb24cf296c26d">HAlignment</a>;</div>
<div class="line"><a id="l00056" name="l00056"></a><span class="lineno">   56</span> </div>
<div class="line"><a id="l00057" name="l00057"></a><span class="lineno">   57</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; <a class="code hl_struct" href="structgg_1_1Margins.html">Margins</a>;</div>
<div class="line"><a id="l00058" name="l00058"></a><span class="lineno">   58</span> </div>
<div class="line"><a id="l00059" name="l00059"></a><span class="lineno">   59</span><span class="keyword">template</span> &lt;&gt; [[nodiscard]] <span class="keyword">auto</span> <a class="code hl_function" href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">Attributes::Get</a>(<span class="keyword">const</span> std::string &amp;) <span class="keyword">const</span> -&gt; <a class="code hl_class" href="classgg_1_1XMLDocument.html">XMLDocument</a> *;</div>
<div class="line"><a id="l00060" name="l00060"></a><span class="lineno">   60</span> </div>
<div class="line"><a id="l00061" name="l00061"></a><span class="lineno">   61</span>}; <span class="comment">// namespace gg</span></div>
<div class="ttc" id="aclassgg_1_1Attributes_html"><div class="ttname"><a href="classgg_1_1Attributes.html">gg::Attributes</a></div><div class="ttdef"><b>Definition:</b> Attributes.hpp:14</div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html_a44e4ec4f45130e843b036c764c9effff"><div class="ttname"><a href="classgg_1_1Attributes.html#a44e4ec4f45130e843b036c764c9effff">gg::Attributes::Get</a></div><div class="ttdeci">auto Get(const std::string &amp;) const -&gt; T</div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html_a86612a57ebf30fff909356a0165a712a"><div class="ttname"><a href="classgg_1_1Attributes.html#a86612a57ebf30fff909356a0165a712a">gg::Attributes::Get</a></div><div class="ttdeci">auto Get(const std::string &amp;) const -&gt; std::string</div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html_a9f8f053a797c33195cd823bbe91a24a8"><div class="ttname"><a href="classgg_1_1Attributes.html#a9f8f053a797c33195cd823bbe91a24a8">gg::Attributes::Add</a></div><div class="ttdeci">void Add(const std::string &amp;, const std::string &amp;)</div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html_aac496caf3931b8885961264bf2015024"><div class="ttname"><a href="classgg_1_1Attributes.html#aac496caf3931b8885961264bf2015024">gg::Attributes::SetLibrary</a></div><div class="ttdeci">void SetLibrary(std::map&lt; std::string, std::string &gt; &amp;new_attr_library)</div><div class="ttdef"><b>Definition:</b> Attributes.hpp:26</div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html_ac0a763b9415d0addc52f108b2febefa1"><div class="ttname"><a href="classgg_1_1Attributes.html#ac0a763b9415d0addc52f108b2febefa1">gg::Attributes::~Attributes</a></div><div class="ttdeci">virtual ~Attributes()=default</div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html_ad955fb8678355b77c60907fe41f754e9"><div class="ttname"><a href="classgg_1_1Attributes.html#ad955fb8678355b77c60907fe41f754e9">gg::Attributes::GetLibrary</a></div><div class="ttdeci">auto GetLibrary() const -&gt; const std::map&lt; std::string, std::string &gt;</div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html_ae2128837ba7b64ae153d8b054d32af58"><div class="ttname"><a href="classgg_1_1Attributes.html#ae2128837ba7b64ae153d8b054d32af58">gg::Attributes::Has</a></div><div class="ttdeci">auto Has(const std::string &amp;) const -&gt; bool</div></div>
<div class="ttc" id="aclassgg_1_1Attributes_html_afad9a1871b7ec801c4c40446a5022bbe"><div class="ttname"><a href="classgg_1_1Attributes.html#afad9a1871b7ec801c4c40446a5022bbe">gg::Attributes::Attributes</a></div><div class="ttdeci">Attributes()=default</div></div>
<div class="ttc" id="aclassgg_1_1XMLDocument_html"><div class="ttname"><a href="classgg_1_1XMLDocument.html">gg::XMLDocument</a></div><div class="ttdef"><b>Definition:</b> XMLDocument.hpp:10</div></div>
<div class="ttc" id="anamespacegg_html"><div class="ttname"><a href="namespacegg.html">gg</a></div><div class="ttdef"><b>Definition:</b> Application.hpp:22</div></div>
<div class="ttc" id="anamespacegg_html_a590f5e8566d42718b935361a0172b54d"><div class="ttname"><a href="namespacegg.html#a590f5e8566d42718b935361a0172b54d">gg::VAlignment</a></div><div class="ttdeci">VAlignment</div><div class="ttdef"><b>Definition:</b> Box.hpp:12</div></div>
<div class="ttc" id="anamespacegg_html_a59e8f774a3ab30332c9369908203b584ab9ece18c950afbfa6b0fdbfa4ff731d3"><div class="ttname"><a href="namespacegg.html#a59e8f774a3ab30332c9369908203b584ab9ece18c950afbfa6b0fdbfa4ff731d3">gg::RoadType::T</a></div><div class="ttdeci">@ T</div></div>
<div class="ttc" id="anamespacegg_html_a8ae82840d9f1b628101cb24cf296c26d"><div class="ttname"><a href="namespacegg.html#a8ae82840d9f1b628101cb24cf296c26d">gg::HAlignment</a></div><div class="ttdeci">HAlignment</div><div class="ttdef"><b>Definition:</b> Box.hpp:10</div></div>
<div class="ttc" id="anamespacestd_html"><div class="ttname"><a href="namespacestd.html">std</a></div><div class="ttdef"><b>Definition:</b> Event.hpp:84</div></div>
<div class="ttc" id="astructgg_1_1Margins_html"><div class="ttname"><a href="structgg_1_1Margins.html">gg::Margins</a></div><div class="ttdef"><b>Definition:</b> Box.hpp:14</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by&#160;<a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.3
</small></address>
</body>
</html>
